#ifndef AUTOBOOT_H
#define AUTOBOOT_H

#include <QFile>

#include "sioworker.h"

class AutoBoot : public SioDevice
{
    Q_OBJECT

private:
    QFile file;
    QByteArray bootSectors[3];
    int sectorCount;

public:
    AutoBoot(SioWorker *worker): SioDevice(worker) {}
    ~AutoBoot();
    void handleCommand(quint8 command, quint16 aux);
    bool open(const QString &fileName);
    void close();
    bool readSector(quint16 sector, QByteArray &data);
    QString deviceName();
signals:
    void sectorRead(int current, int all);
};

#endif // AUTOBOOT_H
