#ifndef MESSAGETYPE_H
#define MESSAGETYPE_H

#include <QObject>

class MessageType : public QObject
{
    Q_OBJECT
    Q_ENUMS(UiMessageType)

public:
    enum UiMessageType {
        DebugMessage,
        UnimportantMessage,
        NormalMessage,
        ImportantMessage,
        WarningMessage,
        ErrorMessage
    };
};

#define emitUiMessage(message, type) if (type >= MessageType::DebugMessage) {emit uiMessage(message, type);}

#endif // MESSAGETYPE_H
